import json
import sys
import os
import gzip
import csv
import shutil

switch_songs = ['bn875', 'twctt', 'mnkesk', 'w2mtom', 'zense', 'ryusei', 'kekka2', 'skorpg', 'memesi', 'xjapa2', 'kishi2', 'train', 'natsu', 'howlin', 'poptep', 'lupatr', 'krbld', 'moana', 'pkalol', 'yokait', 'draond', 'sentoc', 'kim100', 'weare0', 'eva', 'chala', 'odoru', 'sanpo', 'anp', 'gumidp', 'gumi10', 'onigir', 'umtube', 'tairik', 'doyo', 'thgrip', 'th1682', 'thbad', 'butamn', 'clscpl', 'clskum', 'clstrk', 'clsine', 'cls10', 'mario4', 'spl2md', 'kirby', 'pacmce', 'nekotm', 'imcanz', 'tecdrv', 'crtrcs', 'aslt', 'rr1', 'sw1op', 'isan', 'tabetm', 'voidse', 'eigas', 'tondem', 'trance', '6ne9om', 'opng2', 'espera', 'antoni', 'hi4kko', 'ramen', 'carniv', 'butou5', 'kuzure', 'mgwrt2', 'carnat', 'iamsyn', 'invara', 'souryu', 'clstoy', 'cls25', 'cls7', 'clscam', 'clsh', 'clsika', 'clsnut', 'jupt', 'clsoft', 'kakunin', 'furiall', 'furidon', 'furikatsu', 'tmap4', '4nkari', 'laputa', 'totoro', 'rouge', 'majotk', 'ponyo', 'mikuse', 'vfshrr', 'iaasny', 'mikuer', 'toori4']

uid = 1
def genUID():
    global uid
    
    modified = False
    for song in switch_musicInfo['items']:
        if song['uniqueId'] == uid:
            uid = uid + 1
            modified = True

    while modified:
        modified = False
        for song in switch_musicInfo['items']:
            if song['uniqueId'] == uid:
                uid = uid + 1
                modified = True

    return uid

#No encoding, because don't care for other values
csvFile = open('songs.csv', 'r')
reader = csv.reader(csvFile)

with gzip.open('romfs/Data/NX/datatable/musicinfo.bin', 'rb') as musicinfo:
    switch_musicInfo = json.load(musicinfo)

removeSongs = []
for row in reader:
    removeSongs.append(row[0]) # lowercase songID

#A loop, but since we removing elements in it, can't ++ each time
i = 0
while (i < len(switch_musicInfo['items'])):
    song = switch_musicInfo['items'][i]
    if (song['id'].lower() not in removeSongs):

        #Delete all the fumen folders
        #only if they're not switch songs
        if (song['id'].lower() not in switch_songs):
            shutil.rmtree('romfs/Data/NX/fumen/enso/' + song['id'].lower())
            shutil.rmtree('romfs/Data/NX/fumen_hitnarrow/enso/' + song['id'].lower())
            shutil.rmtree('romfs/Data/NX/fumen_hitwide/enso/' + song['id'].lower())

            os.unlink('romfs/Data/NX/' + song['songFileName'] + '.nus3bank')

        del switch_musicInfo['items'][i]
        continue
    i = i + 1

print (len(switch_musicInfo['items']))
if (len(switch_musicInfo['items']) > 199):
    print("Still too many songs, please delete some more")

#Fix UIDs, lazy way
for song in switch_musicInfo['items']:
    if song['uniqueId'] >= 200:
        song['uniqueId'] = genUID()

file = gzip.open('romfs/Data/NX/datatable/musicinfo', 'w')
file.write(json.dumps(switch_musicInfo, indent='\t', separators=(',',':')).encode('UTF-8'))
file.close()

os.unlink('romfs/Data/NX/datatable/musicinfo.bin')
os.rename('romfs/Data/NX/datatable/musicinfo', 'romfs/Data/NX/datatable/musicinfo.bin')